<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script>
        document.addEventListener("DOMContentLoaded", () => {
            load_page('first');
            document.querySelectorAll(".nav-link").forEach(link => {
                link.onclick = () => {
                    const page = link.dataset.page;
                    load_page(page);
                    return false;
                };
            });
        });
        window.onpopstate = e => {
            const data = e.state;
            document.title = data.title;
            document.querySelector("#body").innerHTML = data.text;
        };

        function load_page(page){
            const request = new XMLHttpRequest();
            request.open('GET',`/${page}`)
            request.onload = () => {
                const data = request.responseText;
                document.querySelector("#body").innerHTML = data;

                document.title = page;
                history.pushState({"title":page, 'text':data}, page, page);
            };
            request.send();
        };
    </script>
</head>
<body>
    <ul>
        <li><a href="" class="nav-link" data-page="first">First Page</a></li>
        <li><a href="" class="nav-link" data-page="second">second Page</a></li>
        <li><a href="" class="nav-link" data-page="third">third Page</a></li>
    </ul>
    <div id="body"></div>
</body>
</html>